package com.smartgwt.sample.server;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.olap4j.OlapConnection;
import org.olap4j.metadata.Catalog;
import org.olap4j.metadata.Cube;
import org.olap4j.metadata.Dimension;
import org.olap4j.metadata.NamedList;
import org.olap4j.metadata.Schema;

import com.isomorphic.datasource.BasicDataSource;
import com.isomorphic.datasource.DSRequest;
import com.isomorphic.datasource.DSResponse;

public class OLAPDataSourceDimensions extends BasicDataSource {  
	  

	public DSResponse executeAdd(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(req.getValues());
        resp.setStatus(0);
        return resp;  
    }  
	
	public DSResponse executeRemove(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(req.getValues());
        resp.setStatus(0);
        return resp;  
    }
	
	public DSResponse executeFetch(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(fetchRecordsDimensions(req, resp));
        resp.setStatus(0);
        return resp;  
    }  
  
    private List fetchRecordsDimensions (DSRequest req, DSResponse resp) throws Exception {  
    	List collection = new ArrayList();
    	Map criteria = req.getCriteria();
    	String nameCube = criteria.get("nameCube").toString();
    	OlapConnection olapConnection = DBConnection.getConnection();
    	NamedList<Cube> cubes = olapConnection.getOlapSchema().getCubes();		
		Cube cube = cubes.get(nameCube);
		NamedList<Dimension> dimensions = cube.getDimensions();
		Map data = null;
		for (int i = 0; i < dimensions.size(); i++) {
			data = new HashMap();
			data.put("idDimension", dimensions.get(i).getName().replaceAll(" ", ""));
			data.put("nameDimension", dimensions.get(i).getName());
			collection.add(data);
		}
		olapConnection.close();
		return collection;
    }  
    
}